
def build_cumulative_sum_matrix(matrix):
    """
    Função para construir a matriz de soma acumulada.
    """
    rows = len(matrix)
    cols = len(matrix[0])
    cumulative_sum_matrix = [[0] * cols for _ in range(rows)]

    # Preenche a primeira linha e a primeira coluna
    cumulative_sum_matrix[0][0] = matrix[0][0]
    for i in range(1, rows):
        cumulative_sum_matrix[i][0] = cumulative_sum_matrix[i - 1][0] + matrix[i][0]
    for j in range(1, cols):
        cumulative_sum_matrix[0][j] = cumulative_sum_matrix[0][j - 1] + matrix[0][j]

    # Preenche o restante da matriz
    for i in range(1, rows):
        for j in range(1, cols):
            cumulative_sum_matrix[i][j] = cumulative_sum_matrix[i - 1][j] + cumulative_sum_matrix[i][j - 1] - cumulative_sum_matrix[i - 1][j - 1] + matrix[i][j]

    return cumulative_sum_matrix

def submatrix_sum(cumulative_sum_matrix, top_left, bottom_right):
    """
    Função para calcular a soma da submatriz usando a matriz de soma acumulada.
    """
    top_x, top_y = top_left
    bottom_x, bottom_y = bottom_right

    # Calcula a soma total da submatriz
    total_sum = cumulative_sum_matrix[bottom_x][bottom_y]
    if top_x > 0:
        total_sum -= cumulative_sum_matrix[top_x - 1][bottom_y]
    if top_y > 0:
        total_sum -= cumulative_sum_matrix[bottom_x][top_y - 1]
    if top_x > 0 and top_y > 0:
        total_sum += cumulative_sum_matrix[top_x - 1][top_y - 1]

    return total_sum